#!/usr/bin/env python
import sys
from puq import NormalParameter, UniformParameter, Sweep, RapptureHost, Smolyak
import csv, os
import numpy as np
from puq.jpickle import unpickle

sys.stdout = open("gp.out", 'w')
sys.stderr = open("gp.err", 'w')


dfile, pid, varlist, uq_type, args = sys.argv[1:]
cvsname = "params%s.csv" % pid
hname = "puq_%s.hdf5" % pid

print sys.argv[1:]
varlist = unpickle(varlist)
print "varlist=", varlist


v = {}
for p in varlist:
    name, dist = p
    name = str(name)
    print "name=", name
    print "dist=", dist
    if dist[0] == u'gaussian':
        v[name] = NormalParameter(name, name, mean=dist[1], dev=dist[2])
    elif dist[0] == u'uniform':
        v[name] = UniformParameter(name, name, min=dist[1], max=dist[2])
    else:
        print "ERROR: Unknown distribution type: %s" % dist[0]
        sys.exit(1)
if uq_type == "smolyak":
    uq = Smolyak(v.values(), args)
else:
    print "ERROR: Unknown UQ type: %s" % uq_type
    os.chdir('..')
    sys.exit(1)

vals = np.column_stack([p.values for p in uq.params])
names = ['@@'+str(p.name) for p in uq.params]
np.savetxt(cvsname, vals, delimiter=',', header=','.join(names), comments='')

sw = Sweep(uq, RapptureHost('puq', dfile), 'test/vel_add.py')
sw.run(hname, overwrite=True)
